<html devsite><head>
    <title>实现企业电话服务</title>
    <meta name="project_path" value="/_project.yaml"/>
    <meta name="book_path" value="/_book.yaml"/>
  </head>
  <body>
  <!--
      Copyright 2017 The Android Open Source Project

      Licensed under the Apache License, Version 2.0 (the "License");
      you may not use this file except in compliance with the License.
      You may obtain a copy of the License at

          http://www.apache.org/licenses/LICENSE-2.0

      Unless required by applicable law or agreed to in writing, software
      distributed under the License is distributed on an "AS IS" BASIS,
      WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
      See the License for the specific language governing permissions and
      limitations under the License.
  -->

<p>
本文档介绍了为支持企业使用情景而在版本 7.0 中对 Android 框架的电话相关部分进行的更改。本文档的适用对象为制造商，主要介绍与框架相关的电话方面的更改。此外，本文概述了 OEM 需要对负责处理电话相关功能的预装应用执行哪些更改。
</p>

<p>
Android 7.0 增加了一些用于支持企业电话使用情景的新功能，具体包括：</p>

<ul>
<li>跨资料联系人搜索功能 - 允许个人资料中的应用搜索由受管理资料联系人提供程序提供的联系人，联系人信息可存储在任何数据存储服务中，例如存储在设备本机或企业目录内</li><li>跨资料联系人标记 - 将工作联系人与个人联系人明确区分开来</li><li>使连接服务可感知受管理资料 - 受管理资料中的应用可藉此提供各种电话功能，例如提供单独的工作拨号器和工作连接服务</li>
</ul>

<h2 id="examples-and-source">示例和源代码</h2>

<p>
Android 开放源代码项目 (AOSP) 在拨号器、通讯录和短信应用的实现中集成了跨资料联系人搜索和标记功能。
</p>

<p>
例如：
</p><ul>
<li><strong>为工作联系人添加标记</strong>：请参阅 <code>packages/apps/ContactsCommon</code> f3eb5a207bfe0ff3b4ed2350ae5865ed8bc59798<em></em>
</li><li><strong>跨资料搜索</strong>：请参阅 <code>packages/apps/ContactsCommon</code> cd0b29ddbf3648e48f048196c62245d545bc6122<em></em></li>
</ul>

<h2 id="implementation">实现</h2>

<p>
设备实现人员必须在拨号器、通讯录和短信/彩信应用中实现联系人的跨资料使用、搜索、查询和标记功能。</p>

<h3 id="cross-profile-contact-search">跨资料联系人搜索</h3>

<p>
跨资料联系人搜索应使用 Enterprise Contacts API（<code>ContactsContract.Contacts.ENTERPRISE_CONTENT_FILTER_URI</code> 等）实现。该 API 可在 Android EMM 开发者网站上的 <a href="https://developers.google.com/android/work/overview#contacts">EMM 开发者概览</a>中找到。
</p>

<h3 id="work-profile-contact-badging">工作资料联系人标记</h3>

<p>
工作资料联系人标记可通过检查 <code>ContactsContract.Directory.isEntepriseDirectoryId()</code>（如果可用）或通过使用 <code><a href="http://developer.android.com/reference/android/provider/ContactsContract.Contacts.html#isEnterpriseContactId(long)">isEnterpriseContactId</a></code> 来实现。
</p>

<h3 id="managed-profile-aware-connectionservice">可感知受管理资料的连接服务</h3>

<p>
制造商无需修改框架代码来支持该功能，但应该清楚它对电信服务和其他电话功能的影响。
</p>

<h2 id="validation">验证</h2>

<p>
跨资料联系人搜索和标记功能可通过以下方式验证：</p>

<ol>
<li>使用 <a href="https://github.com/googlesamples/android-testdpc">TestDPC</a> 在测试设备上设置受管理资料。</li><li>启用跨资料联系人搜索。
</li><li>在受管理资料中添加本机工作联系人。
</li><li>在个人资料中的系统拨号器、通讯录和短信/彩信应用内搜索该联系人，确认该联系人可以找到并已正确标记。</li>
</ol>

<p>
新增的 CTS 测试可确保底层的跨资料联系人搜索 API 已在以下位置实现：<code>com/android/cts/managedprofile/ContactsTest.java</code>。
</p>

</body></html>